/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package adictosaltrabajo;

import com.jme.scene.Node;
import com.jme.math.*;
import com.jme.scene.Spatial;
import com.jme.scene.shape.AxisRods;
import java.util.Random;

/**
 *
 * @author rcanales
 */
public class Mosca extends Node {

    Spatial mosca;
    private Quaternion q1 = new Quaternion();
    private Quaternion q2 = new Quaternion();
    private Quaternion q3 = new Quaternion();
    private Vector3f leanAxis = new Vector3f(0, 1, 0);
    private Vector3f vaux = new Vector3f();
    private Vector3f vmov = new Vector3f();
    private Vector3f aux = new Vector3f(0f, 0f, 1f);
    private float Velocidad = 3f;
    private boolean primeravez = true;
    float xini, zini, xfin, xac, zac, zfin, incx, incz;

    public Mosca(String id, Spatial pmosca) {

        super(id);
        this.detachChild(this.mosca);
        mosca = pmosca;

        this.attachChild(this.mosca);
    }

    public void update(float time) {

        MoverAdelante(vmov);
    }

    public void Stop() {
        this.localTranslation.addLocal(0, 0, 0);
    }

    public void GoTo(Vector3f destino) {


        mosca.worldToLocal(destino, vaux);

        if (destino != mosca.getLocalTranslation()) {


            if (primeravez == true) {
                vmov = vaux.divide(10);
                primeravez = false;

                RotarMosca(vaux);


            }
            MoverAdelante(vmov);

        }
    }

    public void MoverAdelante(Vector3f donde) {
        this.localTranslation.addLocal(donde);


    }

    public void MoverAtras() {
        this.localTranslation.addLocal(0.2f, 0.0f, -0.2f);
    }

    public void DesplazarMosca() {
        int Direccion;

        Random rnd = new Random();

        Direccion = (int) (rnd.nextDouble() * 2);

        if (Direccion == 1) {
            this.getLocalTranslation().addLocal(1, 0, 0);
        } else {
            this.getLocalTranslation().addLocal(-1, 0, 0);
        }


    }

    public void mueveMosca(int accion) {


        if (accion == MoverMoscaKeyInputAction.DERECHA) {
            this.getLocalTranslation().addLocal(-1, 0, 0);

        }
        if (accion == MoverMoscaKeyInputAction.IZQUIERDA) {
            this.getLocalTranslation().addLocal(1, 0, 0);
        }
        if (accion == MoverMoscaKeyInputAction.ABAJO) {
            this.getLocalTranslation().addLocal(0, 0, -1);
        }
        if (accion == MoverMoscaKeyInputAction.ARRIBA) {
            this.getLocalTranslation().addLocal(0, 0, 1);
        }


    }

    public void RotarMosca(Vector3f donde) {       

        this.getLocalRotation().fromAngleAxis(aux.angleBetween(donde.normalize()), this.leanAxis);
    }
}
